# DEMO 3

eszkozazonosito = "qgis:exportaddgeometrycolumns"
processing.algorithmHelp(id = eszkozazonosito)


# DEMO 4

for eszkoz in QgsApplication.processingRegistry().algorithms():
	print(eszkoz.id() + " teljes neve:\t" + eszkoz.displayName())

# DEMO 5

# https://docs.qgis.org/3.22/en/docs/user_manual/processing_algs/qgis/vectorgeometry.html#centroids
centroid_azonosito = "native:centroids"
munkamappa = "s:/Oktatás, tanulás/Oktatás, tanulás 2022_23_2_tavasz/Open Source GIS/gyakorlat/05 Eszközök futtatása Pythonnal"
kozeptajak_reteg = QgsProject.instance().mapLayersByName(layerName = "kozeptajak")[0]
parameterek_bonyolult = {
	"INPUT": kozeptajak_reteg,
	"ALL_PARTS": True,
	"OUTPUT": munkamappa + "/kozeptajak_kozeppontjai.shp"
}
centroid_eredmeny = processing.run(algOrName = centroid_azonosito, parameters = parameterek_bonyolult)
centroid_eredmeny["OUTPUT"] # ez szöveg típusú
QgsProject.instance().addMapLayer(mapLayer = centroid_eredmeny["OUTPUT"]) # úgyhogy ez hibát dob
kozeppontok = QgsVectorLayer(path = centroid_eredmeny["OUTPUT"], baseName = "kozeppontok", providerLib = "ogr")
QgsProject.instance().addMapLayer(mapLayer = kozeppontok)
QgsProject.instance().removeMapLayer(layer = kozeppontok) # de most távolítsuk el inkább...
centroid_eredmeny2 = processing.runAndLoadResults(algOrName = centroid_azonosito, parameters = parameterek_bonyolult) # így egy fokkal egyszerűbb
parameterek_egyszeru = {
	"INPUT": "kozeptajak", # rétegek egyszerűen a nevükkel is megadhatóak
	"ALL_PARTS": True,
	"OUTPUT": "TEMPORARY_OUTPUT"
}
centroid_eredmeny3 = processing.execAlgorithmDialog(algOrName = centroid_azonosito, parameters = parameterek_egyszeru)
print("A(z) '" + centroid_eredmeny3["OUTPUT"] + "' azonosítójú réteget létrehoztam és hozzáadtam a tartalomjegyzékhez.")

# Feladat 1

voronoi_azonosito = "qgis:voronoipolygons"
for eszkoz in QgsApplication.processingRegistry().algorithms():
	if eszkoz.id() == voronoi_azonosito:
		print("Az eszköz QGIS-beli neve: " + eszkoz.displayName())

processing.algorithmHelp(id = voronoi_azonosito)
parameterek = {
	"INPUT" : munkamappa + "/varosok_karpat_medenceben.shp",
	"BUFFER": 0,
	"OUTPUT": "TEMPORARY_OUTPUT"
}
voronoi_eredmeny = processing.run(algOrName = voronoi_azonosito, parameters = parameterek)
eredmenyreteg = voronoi_eredmeny["OUTPUT"]
print(eredmenyreteg.id())
if eredmenyreteg.isTemporary():
	QgsProject.instance().addMapLayer(mapLayer = eredmenyreteg)


# DEMO 6

kivalasztas_eredmenye = processing.run(algOrName = "qgis:selectbyattribute", parameters = {
	"INPUT": "varosok_karpat_medenceben",
	"FIELD": "name",
	"OPERATOR": 0,
	"VALUE": "Budapest",
	"METHOD": 0}
)
QgsVectorLayer.SetSelection
QgsVectorLayer.AddToSelection
QgsVectorLayer.IntersectSelection
QgsVectorLayer.RemoveFromSelection
kivalasztas_eredmenye = processing.run(algOrName = "qgis:selectbyattribute", parameters = {
	"INPUT": "varosok_karpat_medenceben",
	"FIELD": "name",
	"OPERATOR": 0,
	"VALUE": "Tatabánya",
	"METHOD": QgsVectorLayer.AddToSelection}
)

# DEMO 7

megnyitott_projekt = QgsProject.instance()
budapest_es_tatabanya = megnyitott_projekt.mapLayersByName(layerName = kivalasztas_eredmenye["OUTPUT"])[0]
if len(budapest_es_tatabanya.selectedFeatures()) > 1: # ha legalább két elem van kijelölve
	osszevonas_eredmenye = processing.runAndLoadResults(
		algOrName = "native:dissolve",
		parameters = {
			"INPUT": QgsProcessingFeatureSourceDefinition(
				source = kivalasztas_eredmenye["OUTPUT"],
				selectedFeaturesOnly = True),
			"FIELD": [],
			"OUTPUT": "TEMPORARY_OUTPUT"
		}
	)

puffermeret = 50000
kilog_magyarorszag_a_pufferbol = True
while kilog_magyarorszag_a_pufferbol:
	puffer_eredmenye = processing.run(
		algOrName = "native:buffer",
		parameters = {
			"INPUT": osszevonas_eredmenye["OUTPUT"],
			"DISTANCE": puffermeret,
			"SEGMENTS": 5,
			"END_CAP_STYLE": 0,
			"JOIN_STYLE": 0,
			"MITER_LIMIT": 2,
			"DISSOLVE": False,
			"OUTPUT": "TEMPORARY_OUTPUT"
		}
	)
	kijeloles_eredmenye = processing.run(
		algOrName = "native:selectbylocation",
		parameters = {
			"INPUT": puffer_eredmenye["OUTPUT"], # azon pufferek (0 vagy 1 darab)
			"PREDICATE": [1], # amelyek tartalmazzák
			"INTERSECT": "magyarorszag", # Magyarország poligonját
			"METHOD": QgsVectorLayer.SetSelection # kerüljenek kijelölésre
		}
	)
	kilog_magyarorszag_a_pufferbol = len(kijeloles_eredmenye["OUTPUT"].selectedFeatures()) == 0 # még mindig kilóg-e Magyarország a pufferből
	if kilog_magyarorszag_a_pufferbol:
		print("Megpróbáltam a(z) " + str(puffermeret / 1000) + " km-es puffert, de túl kicsinek bizonyult.")
		puffermeret = puffermeret + 50000 # növeli a puffert

print("Készen vagyunk, a(z) "  + str(puffermeret / 1000) + " km-es puffer már elégségesnek bizonyult.")
QgsProject.instance().addMapLayer(mapLayer = puffer_eredmenye["OUTPUT"]) # hozzáadjuk a rétegkezelőhöz

# Feladat 2

pontok_szama_sorozat = range(50, 550, 50)
for pontok_szama in pontok_szama_sorozat:
	pontkeszites_eredmenye = processing.run(
		algOrName = "qgis:randompointsinsidepolygons", 
		parameters = {
			"INPUT": "magyarorszag",
			"STRATEGY": 0,
			"VALUE": pontok_szama,
			"MIN_DISTANCE": 5000,
			"OUTPUT": "TEMPORARY_OUTPUT"
		}
	)
	leszamlalas_eredmenye = processing.run(
		algOrName = "qgis:countpointsinpolygon",
		parameters = {
			"POLYGONS": "kozeptajak",
			"POINTS": pontkeszites_eredmenye["OUTPUT"],
			"FIELD": "beleeso_pontok_szama",
			"OUTPUT": "TEMPORARY_OUTPUT"
		}
	)
	kivalasztas_eredmenye = processing.run(
		algOrName = "qgis:selectbyattribute",
		parameters = {
			"INPUT": leszamlalas_eredmenye["OUTPUT"],
			"FIELD": "beleeso_pontok_szama",
			"OPERATOR": 0,
			"VALUE": 0,
			"METHOD": QgsVectorLayer.SetSelection
		}
	)
	print(str(pontok_szama) + " véletlen pont generálása esetén " + str(len(kivalasztas_eredmenye["OUTPUT"].selectedFeatures())) + " középtájba nem került pont.")

# QgsProject.instance().addMapLayer(mapLayer = pontkeszites_eredmenye["OUTPUT"]) # ellenőrzésképpen hozzáadhatjuk a rétegkezelőhöz

